---------------------------------------------------
-- IM_DropDown_Load
---------------------------------------------------
function IM_DropDown_Load()

	--location
	UIDropDownMenu_Initialize(IM_Location_DropDown, IM_Location_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Location_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_LOCATION);
	UIDropDownMenu_JustifyText("LEFT", IM_Location_DropDown)

	--rarity
	UIDropDownMenu_Initialize(IM_Rarity_DropDown, IM_Rarity_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Rarity_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_RARITY);
	UIDropDownMenu_JustifyText("LEFT", IM_Rarity_DropDown)	

	--weapon
	UIDropDownMenu_Initialize(IM_Weapons_DropDown, IM_Weapons_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Weapons_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_WEAPONS);
	UIDropDownMenu_JustifyText("LEFT", IM_Weapons_DropDown)
	
	--tradeskills
	UIDropDownMenu_Initialize(IM_Tradeskills_DropDown, IM_Tradeskills_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Tradeskills_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_TRADESKILLS);
	UIDropDownMenu_JustifyText("LEFT", IM_Tradeskills_DropDown)
	
	--armor
	UIDropDownMenu_Initialize(IM_Armor_DropDown, IM_Armor_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Armor_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_ARMOR);
	UIDropDownMenu_JustifyText("LEFT", IM_Armor_DropDown)
	
	--shield
	UIDropDownMenu_Initialize(IM_Shield_DropDown, IM_Shield_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Shield_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_SHIELD);
	UIDropDownMenu_JustifyText("LEFT", IM_Shield_DropDown)
	
	
	--Level
	UIDropDownMenu_Initialize(IM_Level_DropDown, IM_Level_DropDown_Initialize);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Level_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_LEVEL);
	UIDropDownMenu_JustifyText("LEFT", IM_Level_DropDown)
	
end





---------------------------------------------------
-- IM_DropDown Initialize Functions
---------------------------------------------------
function IM_Location_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_LOCATION), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_LOCATION[i].name;
		info.func = IM_Location_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end

function IM_Rarity_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_RARITY), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_RARITY[i].name;
		info.func = IM_Rarity_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end


function IM_Weapons_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_WEAPONS), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_WEAPONS[i].name;
		info.func = IM_Weapons_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end


function IM_Tradeskills_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_TRADESKILLS), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_TRADESKILLS[i].name;
		info.func = IM_Tradeskills_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end


function IM_Armor_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_ARMOR), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_ARMOR[i].name;
		info.func = IM_Armor_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end

function IM_Shield_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_SHIELD), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_SHIELD[i].name;
		info.func = IM_Shield_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end


function IM_Level_DropDown_Initialize()
	local info;
	for i = 1, getn(ItemsMatrix_DROPDOWN_LIST_LEVEL), 1 do
		info = { };
		info.text = ItemsMatrix_DROPDOWN_LIST_LEVEL[i].name;
		info.func = IM_Level_DropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end

end



---------------------------------------------------
-- IM DropDown_OnClick Functions
---------------------------------------------------
function IM_Location_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Location_DropDown, this:GetID());
end
function IM_Rarity_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Rarity_DropDown, this:GetID());
end
function IM_Weapons_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Weapons_DropDown, this:GetID());
end
function IM_Tradeskills_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Tradeskills_DropDown, this:GetID());
end
function IM_Armor_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Armor_DropDown, this:GetID());
end
function IM_Shield_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Shield_DropDown, this:GetID());
end
function IM_Level_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(IM_Level_DropDown, this:GetID());
end






---------------------------------------------------
-- ItemsMatrix_Search
---------------------------------------------------
function ItemsMatrix_Search()


	    if ItemsMatrixSearchFrame:IsVisible() then
		HideUIPanel(ItemsMatrixSearchFrame);
	    else
		ShowUIPanel(ItemsMatrixSearchFrame);
		HideUIPanel(IM_MoneyOptFrame);
		HideUIPanel(ItemsMatrix_OptionsFrame);
		HideUIPanel(IM_FilterFrame);
	    end
    

end


---------------------------------------------------
-- ItemsMatrix_SearchNow Start Search Process
---------------------------------------------------
function ItemsMatrix_SearchNow()

local iNew = 1;
local index;
local value;
	
	IM_DisplayIndices = { };
	
	--check IMDB
	if(not IMDB) then return nil; end
	
	--check for realm
	if(not IM_Realm) then return nil; end
	
	--check realm DB
	if(not IMDB[IM_Realm]) then return nil; end
	
	for index, value in IMDB[IM_Realm] do
	
		if( ItemsMatrix_MatchSearch(index) ) then
			IM_DisplayIndices[iNew] = index;
			iNew = iNew + 1;
		end
		
	end
	
	IM_DisplayIndices.onePastEnd = iNew;

	--sort it alphabetically
	table.sort(IM_DisplayIndices);
		

	--call refresh to show new search
	ItemsMatrix_Refresh();


end



---------------------------------------------------
-- ItemsMatrix_SearchNow Start Search Process
---------------------------------------------------
function ItemsMatrix_MatchSearch(sName)

local sRarity = 0;
local sRarity_string = nil;
local sWL = 0;
local sWT = 0;
local sTS = 0;
local sAT = 0;
local sST = 0;

local sLvl1 = 0;
local sLvl2 = 0;

	--make sure there is a realm
	if(not IM_Realm) then return nil; end

	--make sure we have a name
	if(not sName) then return nil; end

	--check IMDB
	if(not IMDB) then return nil; end
	
	--check for realm
	if(not IM_Realm) then return nil; end
	
	--check realm DB
	if(not IMDB[IM_Realm]) then return nil; end

	--check realm DB item
	if(not IMDB[IM_Realm][sName]) then return nil; end
	

	IM_SearchActivated = 1; --set search activated


	--------------------------------------------
	--check rarity
	if( ItemsMatrix_DROPDOWN_LIST_RARITY[UIDropDownMenu_GetSelectedID(IM_Rarity_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_RARITY[UIDropDownMenu_GetSelectedID(IM_Rarity_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sRarity = 0;
				sRarity_string = nil; --just to make sure
			else
				sRarity = 1;
				sRarity_string = sortType;
			end
			
			
	end
	
	
	
	--------------------------------------------
	--check weapon location
	if( ItemsMatrix_DROPDOWN_LIST_LOCATION[UIDropDownMenu_GetSelectedID(IM_Location_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_LOCATION[UIDropDownMenu_GetSelectedID(IM_Location_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sWL = 0;
			else
				sWL = IM_WeaponLocation[sortType];
			end
	end
	
	
	--------------------------------------------
	
	--------------------------------------------
	--check weapon type
	if( ItemsMatrix_DROPDOWN_LIST_WEAPONS[UIDropDownMenu_GetSelectedID(IM_Weapons_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_WEAPONS[UIDropDownMenu_GetSelectedID(IM_Weapons_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sWT = 0;
			else
				sWT = IM_WeaponTypes[sortType];
			end
	end
	--------------------------------------------
	

	--------------------------------------------
	--check tradeskill
	if( ItemsMatrix_DROPDOWN_LIST_TRADESKILLS[UIDropDownMenu_GetSelectedID(IM_Tradeskills_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_TRADESKILLS[UIDropDownMenu_GetSelectedID(IM_Tradeskills_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sTS = 0;
			else
				sTS = IM_TradeSkills[sortType];
			end
	end
	--------------------------------------------
	
	
	--------------------------------------------
	--check armor type
	if( ItemsMatrix_DROPDOWN_LIST_ARMOR[UIDropDownMenu_GetSelectedID(IM_Armor_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_ARMOR[UIDropDownMenu_GetSelectedID(IM_Armor_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sAT = 0;
			else
				sAT = IM_ArmorTypes[sortType];
			end
	end
	--------------------------------------------


	--------------------------------------------
	--check shield type
	if( ItemsMatrix_DROPDOWN_LIST_SHIELD[UIDropDownMenu_GetSelectedID(IM_Shield_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_SHIELD[UIDropDownMenu_GetSelectedID(IM_Shield_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sST = 0;
			else
				sST = IM_ShieldTypes[sortType];
			end
	end
	--------------------------------------------
	
	
	--------------------------------------------
	--check level
	if( ItemsMatrix_DROPDOWN_LIST_LEVEL[UIDropDownMenu_GetSelectedID(IM_Level_DropDown)].sortType ) then
	
			local sortType = ItemsMatrix_DROPDOWN_LIST_LEVEL[UIDropDownMenu_GetSelectedID(IM_Level_DropDown)].sortType;
			
			if( sortType == "NONE" ) then
				sLvl1 = 0;
				sLvl2 = 0;
			else
				if(sortType == 0) then
					sLvl1 = 1;
					sLvl2 = 5;
				elseif(sortType == 1) then
					sLvl1 = 5;
					sLvl2 = 10;
				elseif(sortType == 2) then
					sLvl1 = 10;
					sLvl2 = 15;
				elseif(sortType == 3) then
					sLvl1 = 15;
					sLvl2 = 20;
				elseif(sortType == 4) then
					sLvl1 = 20;
					sLvl2 = 25;
				elseif(sortType == 5) then
					sLvl1 = 25;
					sLvl2 = 30;
				elseif(sortType == 6) then
					sLvl1 = 30;
					sLvl2 = 35;
				elseif(sortType == 7) then
					sLvl1 = 35;
					sLvl2 = 40;
				elseif(sortType == 8) then
					sLvl1 = 40;
					sLvl2 = 45;
				elseif(sortType == 9) then
					sLvl1 = 45;
					sLvl2 = 50;
				elseif(sortType == 10) then
					sLvl1 = 50;
					sLvl2 = 55;
				elseif(sortType == 11) then
					sLvl1 = 55;
					sLvl2 = 60;
				end
			end
	end
	
	
	--------------------------------------------



	

--Check Text
--------------------------------------
--------------------------------------		
	
		if(IM_TextEditBox:GetText() and IM_TextEditBox:GetText() ~= "") then

			if  not string.find( string.lower(sName), string.lower( IM_TextEditBox:GetText() ) )  then
				return nil;
			end

		end
	
--------------------------------------
--------------------------------------	



--Check Rarity
--------------------------------------
--------------------------------------		
	
		if(sRarity > 0 and sRarity_string ~= nil) then

			if ( not IM_GetData(sName,"quality")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"quality")) ~= tonumber(sRarity_string)) then
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	


--Check Weapon Location
--------------------------------------
--------------------------------------		
	
		if(sWL > 0) then

			if ( not IM_GetData(sName,"wl")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"wl")) ~= tonumber(sWL)) then
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	


--Check Weapon Type
--------------------------------------
--------------------------------------		
	
		if(sWT > 0) then

			if ( not IM_GetData(sName,"wt")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"wt")) ~= tonumber(sWT)) then
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	


--Check Tradeskill
--------------------------------------
--------------------------------------		
	
		if(sTS > 0) then

			if ( not IM_GetData(sName,"ts")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"ts")) ~= tonumber(sTS)) then
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	
	



--Check Armor Type
--------------------------------------
--------------------------------------		
	
		if(sAT > 0) then

			if ( not IM_GetData(sName,"at")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"at")) ~= tonumber(sAT)) then
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	
		
		
--Check Shield Type
--------------------------------------
--------------------------------------		
	
		if(sST > 0) then

			if ( not IM_GetData(sName,"st")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"st")) ~= tonumber(sST)) then
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	


--Check Level
--------------------------------------
--------------------------------------		
	
		if(sLvl1 > 0 and sLvl2 > 0) then

			if ( not IM_GetData(sName,"level")) then
				return nil;
			end
	
			if ( tonumber(IM_GetData(sName,"level")) >= sLvl1 and tonumber(IM_GetData(sName,"level")) <= sLvl2) then
				--do nothing
			else
				return nil;
			end
			

		end
	
--------------------------------------
--------------------------------------	




	--if EVERYTHING checks out then return yes
	--return yes
	return 1;


end




---------------------------------------------------
-- IM_SearchFrame_Close
---------------------------------------------------
function IM_SearchFrame_Close()

	PlaySound("igMainMenuOption"); 
	HideUIPanel(ItemsMatrixSearchFrame);
	IM_SearchActivated = 0; --reset and refresh
	
	--reset all to NONE
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Location_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_LOCATION);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Rarity_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_RARITY);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Weapons_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_WEAPONS);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Tradeskills_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_TRADESKILLS);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Armor_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_ARMOR);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Shield_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_SHIELD);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Level_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_LEVEL);
	
	IM_TextEditBox:SetText("");
	



end



---------------------------------------------------
-- IM_SearchFrame_Reset
---------------------------------------------------
function IM_SearchFrame_Reset()


	--reset all to NONE
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Location_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_LOCATION);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Rarity_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_RARITY);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Weapons_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_WEAPONS);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Tradeskills_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_TRADESKILLS);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Armor_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_ARMOR);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Shield_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_SHIELD);
	ItemsMatrix_UIDropDownMenu_SetSelectedID(IM_Level_DropDown, 1, ItemsMatrix_DROPDOWN_LIST_LEVEL);
	
	IM_TextEditBox:SetText("");
	
	
end
