--=============================================================================
-- File:		TargetFrameHealthText.lua
-- Author:		 2004, 2005 Miron
--				Barghast
-- Description:	Show target's health percent
--=============================================================================

--=============================================================================
-- Variables
local TargetFrameHealthText_Orig_TargetHealthCheck;
local TargetFrameHealthText_Orig_CheckDead;
--=============================================================================

--=============================================================================
function TargetFrameHealthText_OnLoad()
	TargetFrameHealthText_Orig_TargetHealthCheck = TargetHealthCheck;
	TargetHealthCheck = TargetFrameHealthText_TargetHealthCheck;

	TargetFrameHealthText_Orig_CheckDead = TargetFrame_CheckDead;
	TargetFrame_CheckDead = TargetFrameHealthText_CheckDead;

	TargetDeadText:Show();
end

function TargetFrameHealthText_TargetHealthCheck()
	TargetFrameHealthText_Orig_TargetHealthCheck()
	
	local hpp = TargetFrameHealthBar:GetValue();
	local min, max = TargetFrameHealthBar:GetMinMaxValues();
	hpp = ceil( hpp / max * 100 );

	TargetDeadText:SetText( hpp .. "%" );
end

function TargetFrameHealthText_CheckDead()
	--TargetFrameHealthText_Orig_CheckDead
end
--=============================================================================